package gui;

import java.util.Iterator;
import java.util.List;
import javax.swing.JOptionPane;

import emergenza.Area;
import emergenza.Edificio;
import emergenza.Modello;
import emergenza.Ospedale;
import emergenza.Persona;
import emergenza.PersonaSuperstite;
import emergenza.TipoLinkCollocazione;
import emergenza.TipoLinkContiene;


public class AttivitaIO {

	public static List<RecordArea> inserisciInfoArea() 
	{
		InfoAreaFrame frame=new InfoAreaFrame();
		try 
		{
			synchronized(frame)
			{
				frame.wait();
			}
		} 
		catch (InterruptedException e) {
			e.printStackTrace();
			System.exit(1);
		}
		return frame.getRecordList();
	}

	public static List<String> inserisciEdifici(String nomeArea) 
	{
		InfoEdificiFrame frame=new InfoEdificiFrame(nomeArea);
		try 
		{
			synchronized(frame)
			{
				frame.wait();
			}
		} 
		catch (InterruptedException e) {
			e.printStackTrace();
			System.exit(1);
		}
		return frame.getRecordList();
	}

	public static boolean leggiAgibilita(String indirizzo) 
	{
		int yn=JOptionPane.showConfirmDialog(null,"L'edificio all'indirizzo "+indirizzo+
				"  agibile?","Agibilit",JOptionPane.YES_NO_OPTION);
		return(yn==JOptionPane.YES_OPTION);
	}

	public static List<RecordPersona> leggiQuestionario(String indirizzo) {
		InfoPersonaFrame frame=new InfoPersonaFrame(indirizzo);
		try 
		{
			synchronized(frame)
			{
				frame.wait();
			}
		} 
		catch (InterruptedException e) {
			e.printStackTrace();
			System.exit(1);
		}
		return frame.getRecordList();
	}

	public static void mostraInfoSalienti(RecordArea record) 
	{
		try {
			emergenza.Area ar = Modello.getAreaByNome(record.getNome());
			System.out.println("Area " + ar.getNome() + " (estensione "
					+ ar.getEstensione() + " mq");
			Iterator<TipoLinkContiene> tl = ar.getLink().iterator();
			while (tl.hasNext()) {
				Edificio e = tl.next().getEdificio();
				System.out.println("**** Edificio all'indirizzo "
						+ e.getIndirizzo());
				if (e instanceof Ospedale)
					System.out.println(" E' UN OSPEDALE");
				Iterator<TipoLinkCollocazione> iter = e.getLinkCollocazione().iterator();
				while (iter.hasNext())
				{
					Persona p= iter.next().getPersona();
					System.out.println("        "+p.getNominativo()+ " di anni "+p.getEta());
					System.out.println("VIVO? " +  (p instanceof PersonaSuperstite ? "S":"No"));
					if (p instanceof PersonaSuperstite)
					{
						PersonaSuperstite pV=(PersonaSuperstite)p;
						if(pV.getTipoLinkRecovero()!=null)
							System.out.println("RICOVERATO NELL'OSPEDALE "+pV.getTipoLinkRecovero().getOspedale().getNome());
					}
				}
			}
		} catch (Exception e) 
		{
			e.printStackTrace();
		}
		
	}

	public static RecordArea inserisciNomeArea(List<RecordArea> insieme) {
		Object[] lista=insieme.toArray();
		RecordArea x=null;
		if (lista.length>0)
			x=(RecordArea)JOptionPane.showInputDialog(null,"Selezionare un area:","Selezione",
					JOptionPane.OK_CANCEL_OPTION,null,lista,lista[0]);
		return x;
	}

	public static void visualizzaStatistiche(RecordArea area,float percentualiFeriti, float percentualiVittime) 
	{
		String messaggio="L'area "+area.getNome()+"  caratterizzata da "+ percentualiFeriti +
			"% di feriti "+percentualiVittime+"% di vittime";
		JOptionPane.showMessageDialog(null, messaggio);
	}


}
